## Script (Python) "pay_interswitch_acco"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=paytype=None
##title=
##
# $Id: pay_interswitch_acco.py 2891 2007-12-09 11:03:55Z henrik $
"""
pay online
"""
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass
from urllib import urlencode
import logging
logger = logging.getLogger('Skins.pay_interswitch_acco')
import DateTime

if context.portal_membership.isAnonymousUser():
    return None

request = context.REQUEST
wftool = context.portal_workflow
students = context.portal_url.getPortalObject().campus.students

student_id = context.getStudentId()
if student_id is None:
    return context.REQUEST.RESPONSE.redirect("%s/srp_anonymous_view" % context.portal_url())
student = getattr(students,student_id)

student_record = context.students_catalog.getRecordByKey(student_id)
#amount,description = context.getSchoolFee(student_record.faculty,student_record.session,student_record.course)
now = DateTime.DateTime()
timestamp = "%d" % int(now.timeTime()*1000)
payment_id = "p%s" % timestamp
hostel = paytype == "HOM"
if hostel:
    info = context.getInterswitchParams(paytype,student,payment_id)
    info['student'] = student_record
else:
    info = {}
    info['student'] = student_record
    info['payment_possible'] = False
    info['amount'] = '0'
    info['bank'] = ''
    info['type_description'] = ''
    info['pay_bill_to'] = ''
    fee_dict = context.getSchoolFee(student_record)
    fulltime = student_record.mode.endswith('_ft')
    new = student_record.review_state == 'cleared_and_validated'
    returning = student_record.review_state == 'returning'
    if not fee_dict or (not new and fulltime) or not (new or returning):
        return context.interswitch_form(info=info)
    if new:
        amount = info['amount'] = fee_dict['new']
    elif returning:
        amount = info['amount'] = fee_dict['returning']
    if fulltime:
        pay_item_id = "6100"
        #info['type_code'] = student_record.faculty   #type_code is redundant and will be removed soon
        info['bank'] = ''
    else:
        pay_item_id = "6101"
        #info['type_code'] = student_record.course  #type_code is redundant and will be removed soon
        info['bank'] = ''
    info['payment_possible'] = True
    info['type_description'] = fee_dict['description']
    info['pay_ship_to'] = "University of Benin"
info['pay_bill_to'] = student_record.name
info['student_id'] = student_id
info['student_name'] = student_record.name
info['session_id'] = student_record.session
info['student_email'] = student_record.email
info['date'] = now
info['order_id'] = "%s%s" % (student_id[1:],timestamp)

if "payments" not in student.objectIds():
    student.invokeFactory('PaymentsFolder','payments')
    payments = getattr(student,'payments')
    d = {}
    d['Title'] = 'Payments'
    payments.getContent().edit(mapping=d)
    wftool.doActionFor(payments,'open')
else:
    payments = getattr(student,'payments')
if request.has_key('epayment'):
    return context.interswitch_form(info=info)


payments.invokeFactory('Payment', payment_id)
payment = getattr(payments,payment_id)
wftool.doActionFor(payment,'open')
d = {}
d.update(info)
payment.getContent().edit(mapping=d)
#wftool.doActionFor(payment,'close')
#wftool.doActionFor(student,'pay_school_fee')
info['callback_url'] = "%s/payments/%s/%s?echo=%s" % (student.absolute_url(),
                                                      payment_id,
                                                      info['callback_function'],
                                                      payment_id)

logger.info('%(student_id)s initiated %(type_description)s payment with order_id %(order_id)s and callback url %(callback_url)s' % info)
payment_fields = (('product_id','site_id'),
                  ('site_name','site_name'),
                  ('site_redirect_url','callback_url'),
                  ('Currency','currency_id'),
                  ('cust_id','student_id'),
                  ('cust_id_desc','type_description'),
                  ('cust_name','student_name'),
                  ('txn_ref','order_id'),
                  ('Amount','amount'),
                  ('pay_item_id','pay_item_id'),
                  ('pay_item_name','pay_item_name'),
                  ('payment_params','payment_params'),
                  )
args = {}
for arg,field in payment_fields:
    args[arg] = info[field]
interswitch_amount = int(info['surcharge'])*100
uni_amount = int(info['amount'])*100
total_amount = interswitch_amount + uni_amount
args['Amount'] = "%d" % (total_amount)
args['cust_name_desc'] = "Student Name"
args['xml_data'] = ''
info['args'] = args
return context.goto_interswitch_form(info=info)
